/*
 * This file is a part of morm
 * and is distributed under the 2-Clause BSD licence.
 * Author: Tomasz Sowa <t.sowa@ttmath.org>
 */

/*
 * Copyright (c) 2018-2019, Tomasz Sowa
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef headerfile_morm_morm_types
#define headerfile_morm_morm_types

#define MORM_MODEL_WORK_MODE_NONE 0
#define MORM_MODEL_WORK_MODE_GENERATING_DB_SQL 1
#define MORM_MODEL_WORK_MODE_GENERATING_FLAT_STRING 2
#define MORM_MODEL_WORK_MODE_READING_VALUE_FROM_DB_RESULTSET 3
#define MORM_MODEL_WORK_MODE_CLEARING_VALUE 4
#define MORM_MODEL_WORK_MODE_ITERATE_THROUGH_CHILDS_WITH_FOREIGN_KEY 5
#define MORM_MODEL_WORK_MODE_ITERATE_THROUGH_CHILDS_WITHOUT_FOREIGN_KEY 6
#define MORM_MODEL_WORK_MODE_SET_PARENT_ID 7
#define MORM_MODEL_WORK_MODE_ITERATE_PRIMARY_KEY_VALUES 8
#define MORM_MODEL_WORK_MODE_SET_FIELD_VALUE 9


// submodes used in some cases
#define MORM_MODEL_WORK_SUBMODE_NONE 0
#define MORM_MODEL_WORK_SUBMODE_INSERT 1
#define MORM_MODEL_WORK_SUBMODE_UPDATE 2
#define MORM_MODEL_WORK_SUBMODE_REMOVE 3
#define MORM_MODEL_WORK_SUBMODE_SAVE 4




#define MORM_WORK_MODE_MODEL_FIELDS 1
#define MORM_WORK_MODE_MODEL_VALUES 2
#define MORM_WORK_MODE_MODEL_FIELDS_VALUES 3

#define MORM_WORK_MODE_MODEL_SAVE_FIELDS 4


// IMPROVE ME give me a better name
//#define MORM_WORK_MODE_MODEL_SELECT_FROM_DB 4

//#define MORM_OUTPUT_TYPE_JSON 1
#define MORM_OUTPUT_TYPE_DB_INSERT 2
#define MORM_OUTPUT_TYPE_DB_UPDATE 3

// change to something like MORM_OUTPUT_TYPE_DB_WHERE_PRIMARY_KEY
#define MORM_OUTPUT_TYPE_DB_PRIMARY_KEY 4

#define MORM_OUTPUT_TYPE_DB_INSERT_PRIMARY_KEY 5
#define MORM_OUTPUT_TYPE_DB_UPDATE_PRIMARY_KEY 5


//#define MORM_OUTPUT_TYPE_WHERE_CUSTOM 7
#define MORM_OUTPUT_TYPE_SELECT_COLUMNS 8

#define MORM_OUTPUT_TYPE_JOIN_TABLES 9
#define MORM_OUTPUT_TYPE_COPY_PARENT_KEY 10


#define MORM_OUTPUT_TYPE_WHERE_EQ 20
#define MORM_OUTPUT_TYPE_WHERE_LT 21
#define MORM_OUTPUT_TYPE_WHERE_GT 22
#define MORM_OUTPUT_TYPE_WHERE_LE 23
#define MORM_OUTPUT_TYPE_WHERE_GE 24
#define MORM_OUTPUT_TYPE_WHERE_IN 25
#define MORM_OUTPUT_TYPE_WHERE_NOT_EQ 26


#define MORM_CONJUNCTION_AND 1
#define MORM_CONJUNCTION_OR  2

//#define MORM_DB_TYPE_POSTGRESQL 1


namespace morm
{
} // namespace

#endif
